// document ready functions
$(document).ready(function() {
	
	// TODO
	// Add custom interval settings
	
	// Uncomment to debug new user experience
	/*
	window.CodaPlugInPreferences.setPreferenceForKey(null,'bugify_url');
	window.CodaPlugInPreferences.setPreferenceForKey(null,'api_key');
	window.CodaPlugInPreferences.setPreferenceForKey(null,'issue_type');
	window.CodaPlugInPreferences.setPreferenceForKey(null,'initial_setup');
	*/
	
	// If the settings have been entered, get them
	var url = window.CodaPlugInPreferences.preferenceForKey('bugify_url');
	var api = window.CodaPlugInPreferences.preferenceForKey('api_key');
	var type = window.CodaPlugInPreferences.preferenceForKey('issue_type');
	var noob = window.CodaPlugInPreferences.preferenceForKey('initial_setup');
	
	// Enter them into the settings fields.
	$('#bugify-url').val(url);
	$('#bugify-api-key').val(api);
	$('#bugify-issue-type').val(type);
	
	// If the URL or API Key settings are not found, alert the user and open the settings menu
	if (!url && !api && noob == null) {
		sweetAlert({title: 'Hey, there!', text:'Enter your settings to get started!'});
		$('.settings-tab').addClass('opened');
		$('.settings').show();
	} else {
		getIssues(url,api,type);
	}
	// Section toggle
	$('main > dl > dt').click(function() {
		$(this).toggleClass('opened').next().slideToggle(200);
	});
	
	// Saving the sections
	$('.save-settings').click(function(event){
		
		// Get the entered values for the URL and API Key settings and insert them into the fields
		var bugifyUrl = $('#bugify-url').val();
		var bugifyApi = $('#bugify-api-key').val();
		var issueType = $('#bugify-issue-type').val();
				
		// Verify that the user has entered the URL and the API Key before saving
		if (!bugifyUrl && !bugifyApi) {
			event.preventDefault();
			sweetAlert('Oops!','You need to enter your settings!','error');
		} else if (!bugifyUrl) {
			event.preventDefault();
			sweetAlert('Oops!','You need to enter a URL!','error');
		} else if (!bugifyApi) {
			event.preventDefault();
			sweetAlert('Oops!','You need to enter your API Key!', 'error');
		} else {
			// If both fields have been entered, save the settings and return the Bugify issues
			// Add them as Coda preferences
			window.CodaPlugInPreferences.setPreferenceForKey(bugifyUrl,'bugify_url');
			window.CodaPlugInPreferences.setPreferenceForKey(bugifyApi,'api_key');
			window.CodaPlugInPreferences.setPreferenceForKey(issueType,'issue_type');
			window.CodaPlugInPreferences.setPreferenceForKey('setup','initial_setup');

			getIssues(bugifyUrl,bugifyApi,issueType);
			document.location.reload(true);
		}
	});
	
	$('#toggle-api-key').click(function(){
		var input = $('#bugify-api-key');
		if ($(input).attr('type') == 'password')
        	$(input).attr('type', 'text');
		else 
			$(input).attr('type', 'password');
	});
	
	// Get the current list of issues
	$('.refresh-issues').click(function(event) {
		// Verify that the user has a current URL and API Key entered in settings
		if (!url) {
			event.preventDefault();
			$('.save-settings').click();
		} else if (!api) {
			event.preventDefault();
			$('.save-settings').click();
		} else {
			// If both fields are found, return the Bugify issues
			getIssues(url,api,type);
		}
	});	

	// Functions dealing with updating the details of an issue
	$(document.body).on('click','.issue-details',function() {
		var issueId = $(this).data('issue-id');
		getIssueDetails(url,issueId,api);
	});
	
	$(document.body).on('click','.submit-details-form',function(){
		postIssueDetails(url,api,type);
	});
	
	$(document.body).on('click','.close-details-panel',function() {
		$('.action-panel').slideToggle(100).empty();
		$('.issue-details').removeAttr('disabled');
		$('main').removeClass('issue-details-opened');
	});
	
	// Functions dealing with adding a comment to an issue
	$(document.body).on('click','.issue-comments',function() {
		var issueId = $(this).data('issue-id');
		getIssueComments(url,issueId,api);
		$('.issue-details').removeAttr('disabled');
		$('main').removeClass('issue-details-opened');
	});
	
	$(document.body).on('click','.add-comment',function() {
		var issueId = $(this).data('issue-id');
		getAddComment(url,issueId,api);
	});
	
	$(document.body).on('click','.submit-comment-form',function(){
		postAddComment(url,api,type);
	});
	
	$(document.body).on('click','.close-comments-list',function() {
		$('.action-panel').hide().empty();
		$('.comments-list').slideToggle(100).empty();
		$('.add-comment').removeAttr('disabled');
		$('main').show();
	});
    
    $(document.body).on('click','.close-comment-panel',function() {
		$('.action-panel').slideToggle(100).empty();
		$('.comments-list').removeClass('issue-comments-opened');
		$('.add-comment').removeAttr('disabled');
	});
    
    /*
    // Run the getIssues() function every minute.
    setInterval(function() {
	    url = window.CodaPlugInPreferences.preferenceForKey('bugify_url');
		api = window.CodaPlugInPreferences.preferenceForKey('api_key');
		type = window.CodaPlugInPreferences.preferenceForKey('issue_type');
		getIssues(url,api,type);
	}, 1000 * 60);
	*/
	
	// Prohibit right clicking in the sidebar
	// UNCOMMENT TO DEBUG
	$("*").bind("contextmenu",function(){
       return false;
    })
});